Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 14777)
@@ -1,5 +1,5 @@
 ﻿/// <summary>
-/// For explicit code manipulation and execution. May also be used as a general list data type.
-/// This type must always be present, as the top level interpreter will push any code to be executed on the
+/// For explicit code manipulation and execution. May also be used as a general list data types.
+/// This types must always be present, as the top level interpreter will push any code to be executed on the
 /// CODE stack prior to execution. However, one may turn off all CODE instructions if code manipulation is not needed.
 /// </summary>
@@ -20,5 +20,5 @@
   ///     manipulates the stack then this final pop may end up popping something else.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.DO")]
+  [PushExpression(StackTypes.Code, "CODE.DO", StackTypes.Exec)]
   public class CodeDoExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -36,5 +36,5 @@
   ///     Like CODE.DO but pops the stack before, rather than after, the recursive execution
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.DO*")]
+  [PushExpression(StackTypes.Code, "CODE.DO*", StackTypes.Exec)]
   public class CodeDoXExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -52,5 +52,5 @@
   ///     Does nothing.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.NOOP")]
+  [PushExpression(StackTypes.Code, "CODE.NOOP")]
   public class CodeNoopExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -63,5 +63,5 @@
   ///     This can be implemented by moving the top item on the EXEC stack onto the CODE stack.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.QUOTE")]
+  [PushExpression(StackTypes.Code, "CODE.QUOTE", StackTypes.Exec)]
   public class CodeQuoteExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -81,5 +81,5 @@
   ///     (and the BOOLEAN value upon which the decision was made) are popped.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.IF")]
+  [PushExpression(StackTypes.Code, "CODE.IF", StackTypes.Exec | StackTypes.Boolean)]
   public class CodeIfExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -100,46 +100,54 @@
   ///     literal (that is, something not surrounded by parentheses) then it is surrounded by parentheses first.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.APPEND")]
+  [PushExpression(StackTypes.Code, "CODE.APPEND")]
   public class CodeAppendExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count < 2) return false;
 
-      var first = interpreter.CodeStack.Pop();
-      var second = interpreter.CodeStack.Top;
-
-      var isFirstList = first.IsProgram;
-      var isSecondList = second.IsProgram;
+      var first = interpreter.CodeStack.Top;
+      var second = interpreter.CodeStack.ReverseElementAt(1);
+      PushProgram firstProgram = null;
+      PushProgram secondProgram = null;
+
+      if (first.IsProgram) {
+        firstProgram = (PushProgram)first;
+
+        if (firstProgram.Depth > interpreter.Configuration.MaxDepth) return false;
+
+        if (second.IsProgram) {
+          secondProgram = (PushProgram)second;
+
+          if (secondProgram.Depth > interpreter.Configuration.MaxDepth ||
+              firstProgram.Count + secondProgram.Count > interpreter.Configuration.MaxPointsInProgram)
+            return false;
+        } else if (firstProgram.Count + 1 > interpreter.Configuration.MaxPointsInProgram) return false;
+      } else if (second.IsProgram) {
+        secondProgram = (PushProgram)second;
+
+        if (secondProgram.Depth > interpreter.Configuration.MaxDepth
+            || secondProgram.Count + 1 > interpreter.Configuration.MaxPointsInProgram) return false;
+      } else if (interpreter.Configuration.MaxPointsInProgram <= 2) {
+        return false;
+      }
+
+      interpreter.CodeStack.Pop();
+
+      //var first = interpreter.CodeStack.Pop();
+      //var second = interpreter.CodeStack.Top;
 
       PushProgram result;
 
-      if (isFirstList) {
-        var program1 = first as PushProgram;
-
-        if (isSecondList) {
-          var program2 = second as PushProgram;
-          var size = program2.Expressions.Count + program1.Expressions.Count;
-
-          // if size > maxPointsInProgram this expressions results in a NOOP
-          if (size > interpreter.Configuration.MaxPointsInProgram) return false;
-
-          result = PushProgram.Merge(interpreter.PushProgramPool, program2, program1);
-        } else {
-          var size = program1.Expressions.Count + 1;
-
-          // if size > maxPointsInProgram this expressions results in a NOOP
-          if (size > interpreter.Configuration.MaxPointsInProgram) return false;
-
-          result = PushProgram.Merge(interpreter.PushProgramPool, second, program1);
-        }
-      } else if (isSecondList) {
-        var program2 = second as PushProgram;
-        var size = program2.Expressions.Count + 1;
-
-        // if size > maxPointsInProgram this expressions results in a NOOP
-        if (size > interpreter.Configuration.MaxPointsInProgram) return false;
-
-        result = PushProgram.Merge(interpreter.PushProgramPool, first, program2);
+      if (firstProgram != null) {
+        result = secondProgram != null
+          ? PushProgram.Merge(interpreter.PoolContainer.PushProgramPool, interpreter.PoolContainer.ExpressionListPool, secondProgram, firstProgram)
+          : PushProgram.Merge(interpreter.PoolContainer.PushProgramPool, interpreter.PoolContainer.ExpressionListPool, second, firstProgram);
+      } else if (secondProgram != null) {
+        result = PushProgram.Merge(interpreter.PoolContainer.PushProgramPool, interpreter.PoolContainer.ExpressionListPool, first, secondProgram);
       } else {
-        result = PushProgram.Create(interpreter.PushProgramPool, second, first);
+        var expressions = interpreter.PoolContainer.ExpressionListPool.Get();
+        expressions.Add(second);
+        expressions.Add(first);
+
+        result = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, expressions);
       }
 
@@ -154,5 +162,5 @@
   ///     and FALSE otherwise (that is, if it is something surrounded by parentheses).
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.ATOM")]
+  [PushExpression(StackTypes.Code, "CODE.ATOM", StackTypes.Boolean)]
   public class CodeAtomExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -173,9 +181,9 @@
   ///     The name derives from the similar Lisp function; a more generic name would be "FIRST".
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.CAR")]
+  [PushExpression(StackTypes.Code, "CODE.CAR")]
   public class CodeCarExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
-      if ((interpreter.CodeStack.Count == 0) ||
-          (interpreter.CodeStack.Top.GetType() != typeof(PushProgram))) return false;
+      if (interpreter.CodeStack.Count == 0 ||
+          interpreter.CodeStack.Top.IsProgram) return false;
 
       var expand = interpreter.CodeStack.Top as PushProgram;
@@ -195,5 +203,5 @@
   ///     the similar Lisp function; a more generic name would be "REST".
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.CDR")]
+  [PushExpression(StackTypes.Code, "CODE.CDR")]
   public class CodeCdrExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -208,5 +216,8 @@
         if (program.IsEmpty) return false;
 
-        result = program.Copy(interpreter.PushProgramPool, 0, program.Expressions.Count - 1);
+        var expressions = program.CopyExpressions(interpreter.PoolContainer.ExpressionListPool);
+        expressions.RemoveAt(expressions.Count - 1);
+
+        result = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, expressions as IReadOnlyList<Expression>);
       } else {
         result = PushProgram.Empty;
@@ -223,29 +234,27 @@
   ///     second piece of code is "X" then this pushes "( X A B )" (after popping the argument).
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.CONS")]
+  [PushExpression(StackTypes.Code, "CODE.CONS")]
   public class CodeConsExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
-      if (interpreter.CodeStack.Count < 2)
+      if (interpreter.CodeStack.Count < 2 ||
+         (interpreter.CodeStack.Top.IsProgram &&
+         ((PushProgram)interpreter.CodeStack.Top).Expressions.Count + 1 > interpreter.Configuration.MaxPointsInProgram))
         return false;
 
       PushProgram result;
 
-      if (interpreter.CodeStack.Top.IsProgram) {
-        var first = (PushProgram)interpreter.CodeStack.Pop();
-        var size = first.Expressions.Count + 1;
-
-        if (size > interpreter.Configuration.MaxPointsInProgram) return false;
-
-        var expressions = new Expression[size];
-
-        first.CopyExpressionsTo(expressions);
-        expressions[first.Expressions.Count] = interpreter.CodeStack.Top;
-
-        result = PushProgram.Create(interpreter.PushProgramPool, expressions);
+      var expressions = interpreter.PoolContainer.ExpressionListPool.Get();
+      var first = interpreter.CodeStack.Pop();
+
+      if (first.IsProgram) {
+        expressions.AddRange(((PushProgram)first).Expressions);
       } else {
-        result = PushProgram.Create(interpreter.PushProgramPool, interpreter.CodeStack.Top);
-      }
-
+        expressions.Add(first);
+      }
+
+      expressions.Add(interpreter.CodeStack.Top);
+      result = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, expressions);
       interpreter.CodeStack.SetTop(result);
+
       return true;
     }
@@ -260,5 +269,5 @@
   ///     container.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.CONTAINER")]
+  [PushExpression(StackTypes.Code, "CODE.CONTAINER")]
   public class CodeContainerExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -299,5 +308,5 @@
   ///     item anywhere (e.g. in a sub-list).
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.CONTAINS")]
+  [PushExpression(StackTypes.Code, "CODE.CONTAINS", StackTypes.Boolean)]
   public class CodeContainsExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -321,5 +330,5 @@
   ///     may then be executed with a call to CODE.DO or a similar instruction).
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.DEFINITION")]
+  [PushExpression(StackTypes.Code, "CODE.DEFINITION", StackTypes.Name)]
   public class CodeDefinitionExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -340,12 +349,13 @@
   ///     if the top two items are equivalent, and will be higher the 'more different' the items are from one another. The calculation
   ///     is as follows:
-  ///     <list type="bullet">
+  ///     <list types="bullet">
   ///         <item>
   ///             <description>
   ///                 Construct a list of all of the unique items in both of the lists(where uniqueness is determined by equalp).
   ///                 Sub-lists and atoms all count as items.
+  ///             </description>
   ///         </item>
   ///         <item>
-  ///             <description>Initialize the result to zero.
+  ///             <description>Initialize the result to zero.</description>
   ///         </item>
   ///         <item>
@@ -353,11 +363,12 @@
   ///                 For each unique item increment the result by the difference between the number of occurrences of the
   ///                 item in the two pieces of code.
+  ///             </description>
   ///         </item>
   ///         <item>
-  ///             <description>Push the result.
+  ///             <description>Push the result.</description>
   ///         </item>
   ///     </list>
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.DISCREPANCY")]
+  [PushExpression(StackTypes.Code, "CODE.DISCREPANCY", StackTypes.Integer)]
   public class CodeDiscrepancyExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -417,5 +428,5 @@
   ///     absolute value is taken in case it is negative) to ensure that it is within the meaningful range.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.EXTRACT")]
+  [PushExpression(StackTypes.Code, "CODE.EXTRACT", StackTypes.Integer)]
   public class CodeExtractExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -438,5 +449,5 @@
   ///     Pops the BOOLEAN stack and pushes the popped item (TRUE or FALSE) onto the CODE stack.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.FROMBOOLEAN")]
+  [PushExpression(StackTypes.Code, "CODE.FROMBOOLEAN", StackTypes.Boolean)]
   public class CodeFromBooleanExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -455,5 +466,5 @@
   ///     Pops the FLOAT stack and pushes the popped item onto the CODE stack.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.FROMFLOAT")]
+  [PushExpression(StackTypes.Code, "CODE.FROMFLOAT", StackTypes.Float)]
   public class CodeFromFloatExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -472,5 +483,5 @@
   ///     Pops the INTEGER stack and pushes the popped integer onto the CODE stack.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.FROMINTEGER")]
+  [PushExpression(StackTypes.Code, "CODE.FROMINTEGER", StackTypes.Integer)]
   public class CodeFromIntegerExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -489,5 +500,5 @@
   ///     Pops the NAME stack and pushes the popped item onto the CODE stack.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.FROMNAME")]
+  [PushExpression(StackTypes.Code, "CODE.FROMNAME", StackTypes.Name)]
   public class CodeFromNameExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -507,5 +518,5 @@
   ///     by the top item of the INTEGER stack (and replacing whatever was there formerly).
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.CODEINSERT")]
+  [PushExpression(StackTypes.Code, "CODE.CODEINSERT", StackTypes.Integer)]
   public class CodeInsertExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -519,17 +530,18 @@
       var index = (int)interpreter.IntegerStack.Pop();
 
-      Expression[] newExpressions;
+      IList<Expression> newExpressions;
       if (!target.IsEmpty) {
         index = target.Expressions.Count - 1 - Math.Abs(index % target.Expressions.Count);
-
-        newExpressions = target.CopyExpressions();
+        newExpressions = target.CopyExpressions(interpreter.PoolContainer.ExpressionListPool);
+
         newExpressions[index] = source.IsProgram
-            ? ((PushProgram)source).Copy(interpreter.PushProgramPool)
+            ? ((PushProgram)source).Copy(interpreter.PoolContainer.PushProgramPool)
             : source;
       } else {
-        newExpressions = new[] { source };
-      }
-
-      var result = PushProgram.Create(interpreter.PushProgramPool, newExpressions);
+        newExpressions = interpreter.PoolContainer.ExpressionListPool.Get();
+        newExpressions.Add(source);
+      }
+
+      var result = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, newExpressions as IReadOnlyList<Expression>);
       interpreter.CodeStack.SetTop(result);
 
@@ -544,5 +556,5 @@
   ///     matter what they contain.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.LENGTH")]
+  [PushExpression(StackTypes.Code, "CODE.LENGTH", StackTypes.Integer)]
   public class CodeLengthExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -564,12 +576,20 @@
   ///     Pushes a list of the top two items of the CODE stack onto the CODE stack.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.LIST")]
+  [PushExpression(StackTypes.Code, "CODE.LIST")]
   public class CodeListExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
-      if (interpreter.CodeStack.Count < 2) return false;
+      if (interpreter.CodeStack.Count < 2 ||
+         (interpreter.CodeStack.Top.IsProgram && ((PushProgram)interpreter.CodeStack.Top).Depth == interpreter.Configuration.MaxDepth) ||
+         (interpreter.CodeStack.ReverseElementAt(1).IsProgram && ((PushProgram)interpreter.CodeStack.ReverseElementAt(1)).Depth == interpreter.Configuration.MaxDepth))
+        return false;
 
       var first = interpreter.CodeStack.Pop();
       var second = interpreter.CodeStack.Top;
-      var expandExpression = PushProgram.Create(interpreter.PushProgramPool, second, first);
+
+      var expressions = interpreter.PoolContainer.ExpressionListPool.Get();
+      expressions.Add(second);
+      expressions.Add(first);
+
+      var expandExpression = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, expressions);
 
       interpreter.CodeStack.SetTop(expandExpression);
@@ -583,5 +603,5 @@
   ///     (which is coerced to a list if necessary). Pushes FALSE onto the BOOLEAN stack otherwise.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.MEMBER")]
+  [PushExpression(StackTypes.Code, "CODE.MEMBER", StackTypes.Boolean)]
   public class CodeMemberExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -605,5 +625,5 @@
   ///     modulo the length of the expression into which it is indexing.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.NTH")]
+  [PushExpression(StackTypes.Code, "CODE.NTH", StackTypes.Integer)]
   public class CodeNthExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -643,5 +663,5 @@
   ///     its first element.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.NTHCDR")]
+  [PushExpression(StackTypes.Code, "CODE.NTHCDR", StackTypes.Integer)]
   public class CodeNthCdrExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -676,10 +696,11 @@
   ///     Pushes TRUE onto the BOOLEAN stack if the top item of the CODE stack is an empty list, or FALSE otherwise.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.NULL")]
+  [PushExpression(StackTypes.Code, "CODE.NULL", StackTypes.Boolean)]
   public class CodeNullExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count == 0) return false;
 
-      var result = interpreter.CodeStack.Pop().Equals(PushProgram.Empty);
+      var top = interpreter.CodeStack.Pop();
+      var result = top.IsProgram && ((PushProgram)top).IsEmpty;
       interpreter.BooleanStack.Push(result);
 
@@ -692,5 +713,5 @@
   ///     (which is coerced to a list if necessary). Pushes -1 if no match is found.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.POSITION")]
+  [PushExpression(StackTypes.Code, "CODE.POSITION", StackTypes.Integer)]
   public class CodePositionExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -704,5 +725,5 @@
       if (first.IsProgram) {
         var program = (PushProgram)first;
-        position = program.Expressions.Count - 1 - program.IndexOf(second);
+        position = program.IndexOf(second);
       } else if (first.Equals(second)) {
         position = 0;
@@ -719,5 +740,5 @@
   ///     and pair of parentheses counts as a point.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.SIZE")]
+  [PushExpression(StackTypes.Code, "CODE.SIZE", StackTypes.Integer)]
   public class CodeSizeExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -741,9 +762,10 @@
   ///     cases with empty-list arguments. If any of these problematic possibilities occurs the stack is left unchanged.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.SUBST")]
+  [PushExpression(StackTypes.Code, "CODE.SUBST")]
   public class CodeSubstitutionExpression : StatelessExpression {
     public override bool Eval(IPushInterpreter interpreter) {
-      if ((interpreter.CodeStack.Count < 3) || (interpreter.CodeStack.Top.GetType() !=
-                                                typeof(PushProgram))) return false;
+      if ((interpreter.CodeStack.Count < 3) ||
+          (interpreter.CodeStack.Top.GetType() != typeof(PushProgram)))
+        return false;
 
       var expressions = interpreter.CodeStack.Pop(2);
@@ -752,13 +774,16 @@
       var first = expressions[1] as PushProgram;
       var firstExpressions = first.Expressions;
-      var newExpressions = new Expression[firstExpressions.Count];
-
-      for (var i = 0; i < firstExpressions.Count; i++)
-        newExpressions[i] = firstExpressions[i].Equals(third)
-            ? second
-            /* no cloning needed here because first is removed and therefore newExpression is the only container of sub expressions */
-            : firstExpressions[i];
-
-      var result = PushProgram.Create(interpreter.PushProgramPool, newExpressions);
+      var newExpressions = interpreter.PoolContainer.ExpressionListPool.Get();
+
+      for (var i = 0; i < firstExpressions.Count; i++) {
+        var expression = firstExpressions[i].Equals(third)
+                           ? second
+                           /* no cloning needed here because first is removed and therefore newExpression is the only container of sub expressions */
+                           : firstExpressions[i];
+
+        newExpressions.Add(expression);
+      }
+
+      var result = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, newExpressions);
 
       interpreter.CodeStack.SetTop(result);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 14777)
@@ -31,5 +31,5 @@
   }
 
-  [PushExpression(StackType.Code, "CODE.DEFINE")]
+  [PushExpression(StackTypes.Code, "CODE.DEFINE", StackTypes.Name)]
   public class CodeDefineExpression : DefineExpression<Expression> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -48,5 +48,5 @@
   }
 
-  [PushExpression(StackType.Exec, "EXEC.DEFINE")]
+  [PushExpression(StackTypes.Exec, "EXEC.DEFINE", StackTypes.Name)]
   public class ExecDefineExpression : DefineExpression<Expression> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -66,5 +66,5 @@
   }
 
-  [PushExpression(StackType.Float, "FLOAT.DEFINE")]
+  [PushExpression(StackTypes.Float, "FLOAT.DEFINE", StackTypes.Name)]
   public class FloatDefineExpression : DefineExpression<double> {
 
@@ -78,5 +78,5 @@
   }
 
-  [PushExpression(StackType.Integer, "INTEGER.DEFINE")]
+  [PushExpression(StackTypes.Integer, "INTEGER.DEFINE", StackTypes.Name)]
   public class IntegerDefineExpression : DefineExpression<long> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -89,5 +89,5 @@
   }
 
-  [PushExpression(StackType.Boolean, "BOOLEAN.DEFINE")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.DEFINE", StackTypes.Name)]
   public class BooleanDefineExpression : DefineExpression<bool> {
     public override bool Eval(IPushInterpreter interpreter) {
@@ -99,3 +99,25 @@
     }
   }
+
+  [PushExpression(StackTypes.Char, "CHAR.DEFINE", StackTypes.Name)]
+  public class CharDefineExpression : DefineExpression<char> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(
+        interpreter.CharStack,
+        interpreter.NameStack,
+        interpreter.CustomExpressions,
+        v => new CharPushExpression(v));
+    }
+  }
+
+  [PushExpression(StackTypes.String, "STRING.DEFINE", StackTypes.Name)]
+  public class StringDefineExpression : DefineExpression<string> {
+    public override bool Eval(IPushInterpreter interpreter) {
+      return Eval(
+        interpreter.StringStack,
+        interpreter.NameStack,
+        interpreter.CustomExpressions,
+        v => new StringPushExpression(v));
+    }
+  }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 14777)
@@ -1,7 +1,10 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System;
+
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
 
+  [Serializable]
   public abstract class DoCountExpression : LoopExpression {
 
@@ -15,5 +18,5 @@
 
     protected override LoopState InitState(IPushInterpreter interpreter, IStack<Expression> sourceStack) {
-      var state = new LoopState(
+      var state = LoopState.Create(interpreter.PoolContainer.LoopStatePool,
         body: sourceStack.Pop(),
         currentIndex: 1,
@@ -40,5 +43,6 @@
   ///     ( 0 '1 - IntegerArg>' CODE.QUOTE 'CodeArg' CODE.DO*RANGE )
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.DO*COUNT")]
+  [Serializable]
+  [PushExpression(StackTypes.Code, "CODE.DO*COUNT", StackTypes.Integer)]
   public class CodeDoCountExpression : DoCountExpression {
 
@@ -51,6 +55,9 @@
     }
 
-    protected override LoopExpression Clone(LoopState state) {
-      return new CodeDoCountExpression(state);
+    protected override LoopExpression Clone(LoopState state, IPushInterpreter interpreter) {
+      var expression = interpreter.PoolContainer.GetStatefulExpression<CodeDoCountExpression>();
+      expression.State = state;
+
+      return expression;
     }
   }
@@ -70,5 +77,6 @@
   ///     ( 0 '1 - IntegerArg' EXEC.DO* RANGE'ExecArg' )
   /// </summary>
-  [PushExpression(StackType.Exec, "EXEC.DO*COUNT")]
+  [Serializable]
+  [PushExpression(StackTypes.Exec, "EXEC.DO*COUNT", StackTypes.Integer)]
   public class ExecDoCountExpression : DoCountExpression {
     public ExecDoCountExpression() { }
@@ -79,6 +87,9 @@
     }
 
-    protected override LoopExpression Clone(LoopState state) {
-      return new ExecDoCountExpression(state);
+    protected override LoopExpression Clone(LoopState state, IPushInterpreter interpreter) {
+      var expression = interpreter.PoolContainer.GetStatefulExpression<ExecDoCountExpression>();
+      expression.State = state;
+
+      return expression;
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 14777)
@@ -1,7 +1,10 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System;
+
   using Attributes;
   using Interpreter;
   using Stack;
 
+  [Serializable]
   public abstract class DoRangeExpression : LoopExpression {
     protected DoRangeExpression() { }
@@ -17,5 +20,5 @@
       var incrementor = destinationIndex < interpreter.IntegerStack.Top ? -1 : 1;
 
-      return new LoopState(
+      return LoopState.Create(interpreter.PoolContainer.LoopStatePool,
           body: sourceStack.Pop(),
           currentIndex: interpreter.IntegerStack.Top + incrementor,
@@ -47,5 +50,6 @@
   ///     that is less than the specified current index.
   /// </summary>
-  [PushExpression(StackType.Code, "CODE.DO*RANGE")]
+  [Serializable]
+  [PushExpression(StackTypes.Code, "CODE.DO*RANGE", StackTypes.Integer)]
   public class CodeDoRangeExpression : DoRangeExpression {
     public CodeDoRangeExpression() { }
@@ -56,6 +60,9 @@
     }
 
-    protected override LoopExpression Clone(LoopState state) {
-      return new CodeDoRangeExpression(state);
+    protected override LoopExpression Clone(LoopState state, IPushInterpreter interpreter) {
+      var expression = interpreter.PoolContainer.GetStatefulExpression<CodeDoRangeExpression>();
+      expression.State = state;
+
+      return expression;
     }
   }
@@ -85,5 +92,6 @@
   ///     index that is less than the specified current index.
   /// </summary>
-  [PushExpression(StackType.Exec, "EXEC.DO*RANGE")]
+  [Serializable]
+  [PushExpression(StackTypes.Exec, "EXEC.DO*RANGE", StackTypes.Integer)]
   public class ExecDoRangeExpression : DoRangeExpression {
     public ExecDoRangeExpression() { }
@@ -93,6 +101,9 @@
       return this.Eval(interpreter, interpreter.ExecStack);
     }
-    protected override LoopExpression Clone(LoopState state) {
-      return new ExecDoRangeExpression(state);
+    protected override LoopExpression Clone(LoopState state, IPushInterpreter interpreter) {
+      var expression = interpreter.PoolContainer.GetStatefulExpression<ExecDoRangeExpression>();
+      expression.State = state;
+
+      return expression;
     }
   }
